<?php

// REGZA ライブラリ
include_once('regzamail_config.php');
// **************************************************************************
// REGZA設定から指定時間から，次の側近時間を求める yyyy-mm-dd hh:ii:ss の形式
// **************************************************************************
function NextRegzaTime($qdate) {
	global $REGZA_TIMER;

	$NowTime  = $qdate;
	$NextTime = "";
	sscanf( $qdate, "%04s-%02s-%02s %02s:%02s:%02s", $eyear, $emonth, $eday, $ehour, $emin, $esec );
	$NowDate = $eyear."-". $emonth."-".$eday;

	$MinTime = "";

	foreach ($REGZA_TIMER as $key => $value) {
		$MailTime = $NowDate." ".$value.":00";

		if ($MinTime > $value || $MinTime == "") {  		// 最小設定をサーチ
			$MinTime = $value;
			}

		if ($NowTime < $MailTime) {      					 // 指定時間か未来対象の取込み時間を判定
		    if ($MailTime < $NextTime || $NextTime == "") {  // 更に対象時間がセットされていた判定
    		    $NextTime = $MailTime;
			    }
		    }
		}
	if ($NextTime == "") {									// 本日の予定がない場合明日の初回をセット
		$NowTime  = $NowDate." ".$MinTime.":00";
		$NextTime = computeDate($NowTime,1);
		}

	return($NextTime);
}
// **************************************************************************
// 日数計算 $cdate yyyy-mm-dd hh:ii:ss の形式(時間に関係なく日数を求める)
// **************************************************************************
function computeDate($cdate, $addDays) {
	sscanf( $cdate, "%4d-%2d-%2d %2d:%2d:%2d", $eyear, $emonth, $eday, $ehour, $emin, $esec );
    $baseSec = mktime(0, 0, 0, $emonth, $eday, $eyear);		//基準日を秒で取得
    $addSec = $addDays * 86400;								//日数×１日の秒数
    $targetSec = $baseSec + $addSec;

	sscanf( $cdate, "%4s-%2s-%2s %2s:%2s:%2s", $syear, $smonth, $sday, $shour, $smin, $ssec );
	$targetDay = date("Y-m-d ", $targetSec).$shour.":".$smin.":".$ssec;
    return ($targetDay);
}
// **************************************************************************
// 時間計算 $cdate / $edate yyyy-mm-dd hh:ii:ss の形式
// **************************************************************************
function computehour($cdate, $edate,$unit = 0) {
	sscanf( $cdate, "%4d-%2d-%2d %2d:%2d:%2d", $eyear, $emonth, $eday, $ehour, $emin, $esec );
    $baseSec = mktime($ehour, $emin, $esec, $emonth, $eday, $eyear);	//基準日を秒で取得

	sscanf( $edate, "%4d-%2d-%2d %2d:%2d:%2d", $eyear, $emonth, $eday, $ehour, $emin, $esec );
    $toSec   = mktime($ehour, $emin, $esec, $emonth, $eday, $eyear);	//経過日を秒で取得
    $res_sec = $toSec - $baseSec;
    if ($unit == 0) { $wunit = 1; } else { $wunit = $unit;}
    $res = $res_sec / $wunit;
    return ($res);
}
// **************************************************************************
// 時間計算 $cdate yyyy-mm-dd hh:ii:ss 形式から秒数を計算する。
// **************************************************************************
function computeTime($cdate, $addsec) {
	sscanf( $cdate, "%4d-%2d-%2d %2d:%2d:%2d", $y, $mon, $day, $h, $min, $s );
	$baseSec = mktime( $h, $min, $s, $mon, $day, $y );
	$targetSec =  $baseSec + $addsec;
	$targetDay = date("Y-m-d H:i:s", $targetSec);
    return ($targetDay);

}
// **************************************************************************
// 文字列から 日付(JST)をサーチ＆変換
//         24 Sep 2012 12:00:05 +0900 → 2012/09/24 12:00:05
//         曜日とJST文字列は捨てる。
// **************************************************************************
function JSTDate($jst, &$jststr ,$str = 'Y/m/d H:i:s') {

 $month = array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec' );

 $repstr = str_replace("\r\n", " ", $jst);
 $repstr = str_replace("\n", " ", $repstr);
 $pi = explode(" ", $repstr);

 $jststr = "";$jston = 0;
 foreach ($pi as $p) {
    $p = trim($p);
    if ($jston == 2) {                    // 月検出後のチェック
        if(ereg("^[0-9]+$",$p)) {         // 月の次は年(1900年以下であれば)チェックし再度
           if ((int)$p < 1900)   {
               $jston = 0;                // カウンタをリセット
               }
        } else {
             $jston = 0;                  // カウンタをリセット
             }
        }

    if ($jston == 3) {                    // 時間検出チェック
      if (sscanf($p,"%2s:%2s:%2s",$h,$i,$s) != 3) {
          $jston = 0;                           // カウンタをリセット
          }
      }

    if ($jston == 4) {                    // JSTの+900を検出チェック
      if (!is_numeric($p)) {
          $jston += 1;                       //数値でないときは+900の検出を止める
          }
      }

    if ($jston == 0) {                    // 月未検出
        if (array_search($p,$month)) {             // 文字列に月が出現
            if(ereg("^[0-9]+$",trim($jststr))) {   // 月の前の項目は日(1～31)の範囲か？
              if ((int)(trim($jststr)) > 1 && (int)(trim($jststr)) < 31)
                   $jston = 1;                     // カウンタをセット
                   }
            }
        }
    if ($jston == 0) {            // 月が出現するまで 先頭にセット
        $jststr = $p." ";
    } else if ($jston <= 4) {     // 月を検出後カウンタ３まで（４個）結合する。
        $jststr .= $p." ";
        $jston += 1;
        }
   }

 if ($jston == 4 || $jston == 5) { // カウンタ３： dd mm yyyy hh:ii:ss カウンタ４： dd mm yyyy hh:ii:ss +0900 
     $date = date($str , strtotime($jststr));
 } else {
     return false;
     }
 return $date;
}
?>