<?php
include_once('config.php');
include_once('regzamail_config.php');
include_once( INSTALL_PATH . "/DBRecord.class.php" );
include_once( INSTALL_PATH . "/Settings.class.php" );
include_once( INSTALL_PATH . '/regzalib.php' );

//include_once( INSTALL_PATH . "/reclib.php" );
//include_once( INSTALL_PATH . "/recLog.inc.php" );
include_once( INSTALL_PATH . "/regzamailrecLog.inc.php" );

// 予約クラス

class  Regzamail {
	
	public static function custom(
		$starttime,			// 開始時間Datetime型
		$endtime,			// 終了時間Datetime型
		$channel_id,			// チャンネルID
		$title = "none",		// タイトル
		$description = "none",		// 概要
		$category_id = 0,		// カテゴリID
		$regza_no = 0,		// 録画機
		$usb_id = "none",		// USB HDD ID
		$program_id = 0,		// 番組ID
		$autorec = 0,			// 自動録画
		$mode = 0,			// 録画モード
		$dirty = 0			// ダーティフラグ
	) {

//		global $RECORD_MODE;
		global $REGZA_CHANNEL_MAP;
		global $REGZA_NO;

		$settings = Settings::factory();
		// 時間を計算
		$start_time = toTimestamp( $starttime );
		$end_time   = toTimestamp( $endtime ) + $settings->extra_time;

		$regzatime = NextRegzaTime(date("Y-m-d H:i:s"));	// REGZAのメール受信側近時刻
		$regza_time = toTimestamp( $regzatime );

//		if( $start_time < (time() + PADDING_TIME + 10) ) {	// 現在時刻より3分先より小さい＝すでに開始されている番組
//			$start_time = time() + PADDING_TIME + 10;		// 録画開始時間を3分10秒先に設定する
//		    }
		if( $start_time < ($regza_time + REGZA_PADDING_TIME + 10) ) {	// EGZAのメール受信側近時刻より5分先（設定値)より小さい＝すでに開始されている番組
			$start_time =  $regza_time + REGZA_PADDING_TIME + 10;		// 録画開始時間を3分10秒先に設定する
		    }
		$at_start = $start_time - REGZA_PADDING_TIME;
		$sleep_time = REGZA_PADDING_TIME - $settings->former_time;
		$rec_start = $start_time - $settings->former_time;

		// durationを計算しておく
		$duration = $end_time - $rec_start;
		if( $duration < ($settings->former_time + 60) ) {	// 60秒以下の番組は弾く
			throw new Exception( "REGZAがメール受信までに終わりつつある/終わっている番組です" );
		    }

		$rrec = null;

		try {

			$crec = new DBRecord( CHANNEL_TBL, "id", $channel_id );

			$regza_pass = $REGZA_NO[(int)$regza_no]['passwd'];
			$regza_subject = $title;
			$regza_hdd     = $usb_id;
    		$regza_from    = ADDR_FROM;
			$regza_tomail  = $REGZA_NO[(int)$regza_no]['mailaddr'];

			$regza_stdate  = date("Ymd", $start_time);
			$regza_sttime  = date("Hi", $start_time);
			$regza_endtime = date("Hi", $end_time);

			if ($crec->type === "GR") {						// チャンネルIDを求める
			    foreach ($REGZA_CHANNEL_MAP as $key => $value) {
					if ($crec->type.$crec->channel === $key) {
    					$regza_ch = $value;
						}
					}
			} else if ($crec->type === "BS") {
					   $regza_ch = $crec->type.$crec->channel;
			} else if ($crec->sid === "hd") {
		    		   throw new Exception( "CSの予約はSIDを設定してください。\n");
			} else {   $regza_ch = $crec->type.$crec->sid;
			  }
			$message = "dtvopen"." ".$regza_pass." ".$regza_stdate." ".$regza_sttime." ".$regza_endtime." ".$regza_ch." ".$regza_hdd;
			if (sendmail($regza_from,$regza_tomail,$regza_subject,$message) <> "") {
		    	throw new Exception( "メールの送信に失敗しました。\n");
		    	}
			$regza_req = $regza_stdate."|".$regza_sttime."|".$regza_endtime."|".$regza_ch;
			RegzaReclog( $regza_subject.str_replace ($regza_pass, str_repeat('*', strlen($regza_pass)) , $message)." (".$REGZA_NO[(int)$regza_no]['name'].")",E_RDATA,$regza_req,$program_id );
            return;
			}
		catch( Exception $e ) {
			throw $e;
		}
	}
	// custom 終了

}	

function sendmail($from,$to,$subject,$body)
{
    $server = SMTP_SERVER;
    $port   = SMTP_PORT;
    $subject = mb_convert_encoding("Subject: ".$subject,"iso-2022-jp","UTF-8");
    $body    = mb_convert_encoding($body,"iso-2022-jp","UTF-8");

    $sock = fsockopen($server,$port);        //メールサーバの25番ソケットを開いて
    if (!$sock) {
     RegzaReclog( "メールサーバに接続できません:".$server,E_RERROR);
     return "メールサーバに接続できません\n";
     }
     fputs($sock,"HELO $server\r\n");        // SMTPコマンド発行
     $result = fgets($sock,128);

     fputs($sock,"MAIL FROM:".$from."\r\n"); //FROMアドレス指定
     $result = fgets($sock,128);

     fputs($sock,"RCPT TO:<".$to.">\r\n");   //宛先指定
     $result = fgets($sock,128);

     fputs($sock,"DATA\r\n");                //DATAを送信後、ピリオドオンリーの行を送るまで本文。
     $result = fgets($sock,128);

     fputs($sock,"Date: ".date("r")."\r\n"); //Date ヘッダ送信
     fputs($sock,"From: ".$from."\r\n");     //From ヘッダ送信
     fputs($sock,$subject."\r\n");           //Subjectヘッダ送信
     fputs($sock,"Content-Type: text/plain;charset=ISO-2022-JP"."\r\n");
     fputs($sock,"\r\n".$body."\r\n");       //本文送信
     $result = fgets($sock,128);
     fputs($sock,"\r\n.\r\n");               //ピリオドのみの行を送信。
     $result = fgets($sock);

     if(!ereg("^250",$result)){
        $error_msg = "メール送信失敗\n";
        RegzaReclog( "メール送信失敗:".$result,E_RERROR);
        }
     fclose($sock);
     return($error_msg);
}
?>
