#!/usr/bin/php
<?php
//---------------------------------------------------------------------------
// REGZA cron ファイル作成
//   削除      : regzamailcron.php --remove
//   作成      : regzamailcron.php --make
//   作成&Link : regzamailcron.php
//           CRON_FILEPATH :指定のPathにファイルを作成
//           ディフォルト  :/var/www/epgrec/cron.d/ epgrec標準のフォルダ
//
//   /etc/下の作成権限があるユーザで実行すれば，CRON_FILEPATHに作成後
//   シンボリックリンクを張る。
//
//   regzamail_config.phpの設定時間を行うこと。
//          $REGZA_TIMER + CRON_DERAY
//          を参照して実行時間を設定する。
//---------------------------------------------------------------------------
include_once('config.php');
include_once('regzamail_config.php');
include_once( INSTALL_PATH . '/regzalib.php' );
include_once( INSTALL_PATH . "/Settings.class.php" );

//---------------------------------------------------------------------------
// REGZA cron 定義
//---------------------------------------------------------------------------
//RegzaCreate( );
define("CRON_FILEPATH","/var/www/epgrec/cron.d/");   // 権限のあるフォルダを指定。
define("CRON_FILE","epgrec_regzapop3");     // crontab ファイル名
define("CRON_DIR","/etc/cron.d/");   // ubuntuの場合 /etc/cron.d/

$CRON_HEADER = array(
      "SHELL=/bin/sh",
      "PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin",
      "",
);
define("CRON_DETAIL","%mm %hh * * *   %user	%shell");
define("CRON_DERAY",300);                 // 単位：Sec
define("CRON_USER","www-data");           // cron 実行user
define("CRON_SHELL","regzamailpop3.php"); // cron 実行shell install下

$settings = Settings::factory();

// cron 定義のファイル名(フルパス）
$filename = CRON_FILEPATH.CRON_FILE;
// cron.dに登録のファイル名
$cronname = CRON_DIR.CRON_FILE;
// shell spool path
$spool = INSTALL_PATH.$settings->spool;

// cron remove 判定
$mode_make = 0;
for ($i = 0; $i < $argc; $i++) {
   if ($i > 0) {
      if ($argv[$i] === "--remove") {
          $ret = cronremove($cronname,$filename);
          exit($ret);
      } else if ($argv[$i] === "--make") {
          $mode_make = 1;
      } else { exit("error: 引数が異なります。".$argv[$i]."\n"); }
   }
}

// cron 登録処理
$fp = fopen($filename,"w");
if (!$fp)
   { exit("error: ファイル作成エラー:".$filename."\n"); }

foreach( $CRON_HEADER  as $h ) {   // Header作成
    fwrite($fp,$h."\n");
    }

foreach( $REGZA_TIMER  as $t ) {   // 起動時間定義
    $time    = date("Y-m-d")." ".$t.":00";
    $kiktime = computeTime($time,CRON_DERAY);
    sscanf($kiktime,"%4s-%2s-%2s %2s:%2s:%2s",$yy,$mm,$dd,$hh,$ii,$ss);
    $str = str_replace("%mm",$ii,CRON_DETAIL);
    $str = str_replace("%hh",$hh,$str);
    $str = str_replace("%user",CRON_USER,$str);
    $shell = INSTALL_PATH."/".CRON_SHELL;
    $str = str_replace("%shell",$shell,$str);
    fwrite($fp,$str."\n");
    }
fclose($fp);

if ($mode_make == 0) {
   if ( file_exists($cronname) )
        {   exit("ファイル コピー済 : ".$cronname."\n"); }
   $croncp = "cp ".$filename." ".$cronname;
   $ret = execshell($croncp);
   if(!strncmp($ret,"pipe2",strlen("pipe2")))
      { exit("warning:"."/etc 許可がありません。「".$filename."」を手操作で crontabに登録\n"); }
   }

exit("make end path : ".$cronname."\n");

//---------------------------------------------------------------------------
//  REGZA pop3 corn.d remove
//---------------------------------------------------------------------------
function cronremove($cronname,$filename = "") {

  $retstr = "";
  if (file_exists($cronname)) {
      $rm = "rm ".$cronname;
      $ret = execshell($rm);
      if (!strncmp($ret,"pipe2",strlen("pipe2")))
         {
         $retstr = $cronname." ";
         }
      }

  if (file_exists($filename))  {
      $rm = "rm ".$filename;
      $ret = execshell($rm);
      if (!strncmp($ret,"pipe2",strlen("pipe2")))
         {
         $retstr .= $filename;
         }
      }
    if ($retstr != "") {
       return "wrning:手操作で削除 :".$retstr."\n";
       }
    return "remove end\n";
}
//---------------------------------------------------------------------------
//  shell 実行
//---------------------------------------------------------------------------
function execshell($shell) {
	global $spool;

	$descriptor = array( 0 => array( "pipe", "r" ),
                     1 => array( "pipe", "w" ),
                     2 => array( "pipe", "w" ),
					);
	$process = proc_open( $shell , $descriptor, $pipes, $spool);
		$rstring1 = stream_get_contents( $pipes[1]); 		// 標準エラーを取る
		$rstring2 = stream_get_contents( $pipes[2]);
	    fclose( $pipes[0] );
	    fclose( $pipes[1] );
	    fclose( $pipes[2] );
	    proc_close( $process );
    if ($rstring2) {
        return "pipe2: shell".$shell." 実行エラー:".$rstring2;
        }
    return "shell end\n".$rstring1;
}
?>
