#!/usr/bin/php
<?php
include_once('config.php');
include_once('regzamail_config.php');
include_once( INSTALL_PATH . '/regzalib.php' );

include_once( INSTALL_PATH . "/DBRecord.class.php" );
//include_once(INSTALL_PATH."/reclib.php");
include_once( INSTALL_PATH . "/Settings.class.php" );
include_once( INSTALL_PATH . "/regzamailrecLog.inc.php" );
include_once( INSTALL_PATH . '/regzastoreProgram.inc.php' );

// subjectでREGZAからの応答がない場合の文言を定義しておく。
// REGZAから何らかのメールが返ったとき，REGZAがメール処理している確認できたとして未回答予約にセットする。
// REGZAからの応答メール本文までの間に日付が含まれること
$REGZA_NOREV   = "予約できなかった模様";
// subjectでREGZAからのメールと確定するための文言を定義しておく。(機種ごとまたバージョンの違いは不明)
$REGZA_SUBJECT = "REGZAからのお知らせ";
$REGZA_OKMSG = "予約を登録しました。";
$FLG_MAILDEL   = 1;       // 1:指定時メールを削除する
//---------------------------------------------------------------------------
// REGZA 予約結果メール受信
//---------------------------------------------------------------------------
//RegzaCreate( );
$host = POP3_SERVER;
$user = POP3_USER;
$pass = POP3_PASS;
$port = POP3_PORT;

$settings = Settings::factory();

if ($dbh = mysql_connect( $settings->db_host, $settings->db_user, $settings->db_pass ) == false) {
    exit;
    }

foreach( $REGZA_NO as $R ) {
    $mailtbl = array();
    $regza_address = $R['mailaddr'];
    if ($rtnmsg = pop3get($host,$user,$pass,$port,$regza_address,$mailtbl,0) != true) {
        echo "Error:".$rtnmsg;
        exit;
        }

    $mailret = array();    $maxdate = ""; $no_revcnt = 0;
    foreach( $mailtbl as $m ) {
        $repstr = str_replace("\r\n", " ", $m['body']);  // REGZA応答メールを整形する
        $repstr = str_replace("　", " "  , $repstr);
        $repstr = trim($repstr," ");
        sscanf($repstr,"%s 録画日 %s 録画開始時刻 %s 録画終了時刻 %s チャンネル %s",$reccmt,$recdate,$recstime,$recetime,$recch);
        sscanf(trim($m['subject']),"Subject:%s",$subject);
        if ($REGZA_SUBJECT === $subject) {   // subjectでREGZAからのメールと確定する。($REGZA_SUBJECT = "REGZAからのお知らせ")
            if ($getdate = JSTDate($m['header'],$jstdate,'Y-m-d H:i:s')) {  // REGZA応答メールから最大時間を求める
               if ($getdate > $maxdate) {
                   $maxdate = $getdate;
                   }
               }
            if (!pop3update($R['name'],$dbh,$reccmt,$recdate,$recstime,$recetime,$recch,$getdate)) {
                if(!ereg($REGZA_OKMSG,$reccmt)) {
                   $no_revcnt += 1;
                   }
                }
            $arr = array();              // 削除対象のメールヘッダーを配列にセット
            $arr['header'] = $m['header'];
            array_push( $mailret, $arr );
            }
        }
//  print "Mail Max Time:".$maxdate."\n";
    if ($maxdate != "") {
        notpop3update($R['name'],$dbh,computeTime($maxdate , REGZA_RECEIVE_RAGTIME));
        }
    if ($maxdate != "") {
        $cmt2 = "メール受信日付:".$maxdate;
    } else {
        $cmt2 = "該当メールなし";
      }
    RegzaReclog( "regzamailpop3.php メール受信処理 :".$R['name']." 予約失敗通知: ".$no_revcnt." 件 ",E_RINFO,"",0,$cmt2 );
    if ($rtnmsg = pop3get($host,$user,$pass,$port,$regza_address,$mailtbl,$FLG_MAILDEL,$mailret) != true) {
        echo $rtnmsg;
        }
//  print_r($mailret);
    }
RegzaGarbageClean();      // 過去ログ削除

//---------------------------------------------------------------------------
//  REGZA 応答をDB UPDATE
//---------------------------------------------------------------------------
function pop3update($regzano,$dbh,$reccmt,$recdate,$recstime,$recetime,$recch,$getdate) {

    $sq_recdate  = str_replace("/", "", $recdate);
    $sq_recstime = str_replace(":", "", $recstime);
    $sq_recetime = str_replace(":", "", $recetime);

    if (abs (computehour($getdate,date("Y-m-d H:i:s"),60*60*24)) > 365) {  // メール形式が新表性のある日付？
        $update = date("Y-m-d H:i:s");                                     // 1年の差はあり得ない
    } else {
        $update = $getdate;
        }
    $options = "WHERE regzareq = '".$sq_recdate."|".$sq_recstime."|".$sq_recetime."|".$recch."' and regzarresp = ''";
    $update_id = 0;
    $recs = DBRecord::createRecords( REGZA_LOG_TBL, $options );
    foreach( $recs as $rec ) {
        if (preg_match("/".$regzano."/", $rec->message)) {
            $update_id = $rec->id;
            }
        }
    if ($update_id == 0) {
        return false;
        }
    try {
        $log = new DBRecord( REGZA_LOG_TBL );
        $log->id = $update_id;
        $log->regzarresp = $reccmt."(".$update.")";
        }
	catch( Exception $e ) {
    RegzaReclog( "pop3update REGZA_LOG_TBL update error",E_RERROR);
    echo "Error:pop3update REGZA_LOG_TBL update error\n";
    return false;
    }
    return true;
}

//---------------------------------------------------------------------------
//  REGZA（予約を登録できませんでした。応答からDBが不明
//---------------------------------------------------------------------------
function notpop3update($regzano,$dbh,$maxdate) {
    global $REGZA_NOREV;

//  print "Mail Max Time:".$maxdate." (Ragtime)\n";

    $options = "WHERE logtime < '".$maxdate."' and regzarresp = '' and level = ".E_RDATA;
    $recs = DBRecord::createRecords( REGZA_LOG_TBL, $options );
    foreach( $recs as $rec ) {
        if (preg_match("/".$regzano."/", $rec->message)) {
            $log = new DBRecord( REGZA_LOG_TBL );
            $log->id = $rec->id;
            $log->regzarresp = $REGZA_NOREV."(".$maxdate.")";
            }
        }
    return true;
}
//---------------------------------------------------------------------------
// POP3 メール受信
//---------------------------------------------------------------------------
function pop3get($host,$user,$pass,$port,$regza_address,&$mailtbl,$flg_maildel = 0,$mailret = array()) {
    $socket = pop3connect($host, $port,$message);
    if ($socket == false) {
        return $message."\n";
        }

    // USERコマンド発行
    if ($rtnmsg = pop3sendcmd($socket,"USER ".$user,$buffer,1) != true) {
        return $rtnmsg."\n";
        }
    // PASSコマンド発行
    if ($rtnmsg = pop3sendcmd($socket,"PASS ".$pass,$buffer,1) != true) {
        return $rtnmsg."\n";
        }
    // STATコマンド発行
    if ($rtnmsg = pop3sendcmd($socket,"STAT",$buffer, 1) != true) {
        return $rtnmsg."\n";
        }
    // 戻り値より、メール件数・サイズを取得
    $data = $buffer;
    sscanf($data, '+OK %d %d', $num, $size);

    for ($i=1; $i<=$num; $i++) {
         // RETRコマンド発行
         if ($rtnmsg = pop3sendcmd($socket,"RETR ".$i,$buffer, 1) != true) {
             return $rtnmsg."\n";
             }
         $flg_regza = 0;$flg_body = 0;$flg_Subject = 0;$m_header = "";$m_body = "";$m_Subject = "";
         while (!ereg("^\.\r\n", $buffer)) {
            $buffer = fgets($socket, 512);
            $mb_data = mb_convert_encoding($buffer, "UTF-8", "iso-2022-jp");
            // 送信元該当チェック
            if ($flg_regza == 0 && preg_match("/From:/",$mb_data) && preg_match("/".$regza_address."/",$mb_data)) {
                $flg_regza = 1;
                }
            // メール・Subjectチェック
            if ($flg_Subject == 0 && preg_match("/Subject:/",$mb_data)) {
                $flg_Subject = 1;
                mb_internal_encoding("iso-2022-jp");
                $m_Subject = mb_convert_encoding(mb_decode_mimeheader($buffer),"UTF-8","iso-2022-jp");
                }
            // メール・ヘッダ作成（メールボディが出現まで）：削除時付き合わせる
            if ($flg_body ==  0) {
                $m_header .= $mb_data;
                }
            // メール・ボディチェック
            if ($flg_body == 0 && preg_match("/Content-Type:/",$mb_data)) {
                $flg_body = 1;
            } else if ($flg_body == 1 && !ereg("^\.\r\n", $buffer)) {
                       $m_body .= $mb_data;
                       }
         }
         if ($flg_regza == 1 && $m_body ) {
             $arr = array();
             $arr['header']  = $m_header;
             $arr['subject'] = $m_Subject;
             $arr['body']    = $m_body;
             array_push( $mailtbl, $arr );
             }
        if ($flg_maildel == 1) {       // メール削除モード $mailret arrayで指定されたメールを削除する
            foreach( $mailret as $m ) {
                if ($m['header'] === $m_header) {
                     if ($delmsg = pop3sendcmd($socket,"DELE ".$i,$buffer_dmy, 0) != true) {
                         RegzaReclog( "POP3 メール削除エラーは処理続行，終了後メールを確認し手作業で削除",E_RWARNING);
                        }
                   }
                }
            }
        }
    fputs($socket, "QUIT \r\n");
    fclose($socket);
    return true;
}
// POP3 Server Connect
function pop3connect($host, $port,&$message) {
    // ソケットオープン
    $socket = fsockopen($host, $port, $error_no, $message, 10);
    if ($socket == false) {
        $message = "POP3メールサーバに接続できません"."\n";
        RegzaReclog( "POP3メールサーバに接続できません:".$host,E_RERROR);
        return false;
        }
    $buffer = fgets($socket, 512);
    if (!preg_match("/OK/",$buffer)) {
        $message = "Server Connext Receive Error !+OK "."\n";
        RegzaReclog( "Server Connext Receive Error !+OK ",E_RERROR);
        fputs($socket, "QUIT \r\n");
        fclose($socket);
        return false;
        }
    $message = $buffer;
    return $socket;
}

// POP3 Command Send
function pop3sendcmd($socket,$cmdstr,&$buffer,$responce = 1) {
    fputs($socket,$cmdstr."\r\n");
    if ($responce == 1) {
       $buffer = fgets($socket, 512);
       if (!preg_match("/OK/",$buffer)) {
           fputs($socket, "QUIT \r\n");
           fclose($socket);
           RegzaReclog( "POP3 Command Send Return Error CMD:".$cmdstr,E_RERROR);
           return "POP3 Command Send Return Error CMD:".$cmdstr."\n";
           }
       }
    return true;
}
?>
